var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
import * as Web3 from './web3.min.js';
import BigNumber from 'bignumber.js';
var universeABI = [
    {
        "constant": true,
        "inputs": [],
        "name": "getCurrentFeeWindow",
        "outputs": [{ "name": "", "type": "address" }],
        "payable": false,
        "stateMutability": "view",
        "type": "function"
    },
    {
        "constant": true,
        "inputs": [],
        "name": "getNextFeeWindow",
        "outputs": [{ "name": "", "type": "address" }],
        "payable": false,
        "stateMutability": "view",
        "type": "function"
    },
    {
        "constant": true,
        "inputs": [],
        "name": "getPreviousFeeWindow",
        "outputs": [{ "name": "", "type": "address" }],
        "payable": false,
        "stateMutability": "view",
        "type": "function"
    }
];
var cashABI = [
    {
        "constant": true,
        "inputs": [{ "name": "_owner", "type": "address" }],
        "name": "balanceOf",
        "outputs": [{ "name": "", "type": "uint256" }],
        "payable": false,
        "stateMutability": "view",
        "type": "function"
    }
];
var feeWindowABI = [
    {
        "constant": true,
        "inputs": [],
        "name": "getTotalFeeStake",
        "outputs": [{ "name": "", "type": "uint256" }],
        "payable": false,
        "stateMutability": "view",
        "type": "function"
    },
    {
        "constant": true,
        "inputs": [],
        "name": "getEndTime",
        "outputs": [{ "name": "", "type": "uint256" }],
        "payable": false,
        "stateMutability": "view",
        "type": "function"
    }
];
var DEFAULT_CASH_CONTRACT_ADDRESS = '0xd5524179cB7AE012f5B642C1D6D700Bbaa76B96b';
var DEFAULT_UNIVERSE_CONTRACT_ADDRESS = '0xE991247b78F937D7B69cFC00f1A487A293557677';
var DEFAULT_WEB3_PROVIDER = 'https://mainnet.infura.io/augur';
var AugurFeeWindow = /** @class */ (function () {
    function AugurFeeWindow(web3) {
        this.web3 = web3 || new Web3(Web3.givenProvider || DEFAULT_WEB3_PROVIDER);
    }
    AugurFeeWindow.prototype.setWeb3 = function (web3) {
        this.web3 = web3;
    };
    /**
     *
     * @returns {number} - Gas price in ETH
     */
    AugurFeeWindow.prototype.getGasPrice = function () {
        return __awaiter(this, void 0, void 0, function () {
            var res, resJSON, gasPrice, err_1;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 3, , 4]);
                        return [4 /*yield*/, fetch('https://ethgasstation.info/json/ethgasAPI.json')];
                    case 1:
                        res = _a.sent();
                        return [4 /*yield*/, res.json()];
                    case 2:
                        resJSON = _a.sent();
                        gasPrice = new BigNumber(resJSON.safeLow).shiftedBy(-10);
                        return [2 /*return*/, gasPrice];
                    case 3:
                        err_1 = _a.sent();
                        throw new Error("getGasPrice: " + err_1);
                    case 4: return [2 /*return*/];
                }
            });
        });
    };
    /**
     *
     * @returns {BigNumber} - REP price in ETH
     */
    AugurFeeWindow.prototype.getRepEthPrice = function () {
        return __awaiter(this, void 0, void 0, function () {
            var res, resJSON, repEthPrice, err_2;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 3, , 4]);
                        return [4 /*yield*/, fetch('https://min-api.cryptocompare.com/data/price?fsym=REP&tsyms=ETH')];
                    case 1:
                        res = _a.sent();
                        return [4 /*yield*/, res.json()];
                    case 2:
                        resJSON = _a.sent();
                        repEthPrice = new BigNumber(resJSON.ETH);
                        return [2 /*return*/, repEthPrice];
                    case 3:
                        err_2 = _a.sent();
                        throw new Error("getRepEthPrice: " + err_2);
                    case 4: return [2 /*return*/];
                }
            });
        });
    };
    /**
     *
     * @returns {Promise<FeeWindow>} - The current fee window info
     */
    AugurFeeWindow.prototype.getCurrentFeeWindow = function () {
        return __awaiter(this, void 0, void 0, function () {
            var address, err_3;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 3, , 4]);
                        return [4 /*yield*/, this.universeContract().methods.getCurrentFeeWindow().call()];
                    case 1:
                        address = _a.sent();
                        return [4 /*yield*/, this.getFeeWindow(address, false)];
                    case 2: return [2 /*return*/, _a.sent()];
                    case 3:
                        err_3 = _a.sent();
                        throw new Error("getCurrentFeeWindow: " + err_3);
                    case 4: return [2 /*return*/];
                }
            });
        });
    };
    /**
     *
     * @returns {Promise<FeeWindow>} - The next fee window info
     */
    AugurFeeWindow.prototype.getNextFeeWindow = function () {
        return __awaiter(this, void 0, void 0, function () {
            var address, err_4;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 3, , 4]);
                        return [4 /*yield*/, this.universeContract().methods.getNextFeeWindow().call()];
                    case 1:
                        address = _a.sent();
                        return [4 /*yield*/, this.getFeeWindow(address, false)];
                    case 2: return [2 /*return*/, _a.sent()];
                    case 3:
                        err_4 = _a.sent();
                        throw new Error("getNextFeeWindow: " + err_4);
                    case 4: return [2 /*return*/];
                }
            });
        });
    };
    /**
     * Caution: this method needs a lot of requests and therefore may be slow
     * @returns {Promise<FeeWindow>} - The previous fee window info
     */
    AugurFeeWindow.prototype.getPreviousFeeWindow = function () {
        return __awaiter(this, void 0, void 0, function () {
            var address, err_5;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 3, , 4]);
                        return [4 /*yield*/, this.universeContract().methods.getPreviousFeeWindow().call()];
                    case 1:
                        address = _a.sent();
                        return [4 /*yield*/, this.getFeeWindow(address)];
                    case 2: return [2 /*return*/, _a.sent()];
                    case 3:
                        err_5 = _a.sent();
                        throw new Error("getPreviousFeeWindow: " + err_5);
                    case 4: return [2 /*return*/];
                }
            });
        });
    };
    /**
     * Calculates some profit values for the given input parameter
     * @param {BigNumber} fees - The fees in the fee window in ETH
     * @param {BigNumber} gasPrice - The gas price in ETH
     * @param {BigNumber} gasUsed - The used gas for both transactions (buying participation tokens and redeeming)
     * @param {BigNumber} rep - The number of used REP
     * @param {BigNumber} repEthPrice the REP-ETH price
     * @param {BigNumber} stake the stake in the fee window in REP
     * @returns {ParticipationRentabilityResult}
     */
    AugurFeeWindow.prototype.calculateParticipationRentability = function (fees, gasPrice, gasUsed, rep, repEthPrice, stake) {
        var gasCost = gasPrice.times(gasUsed);
        var totalFeeProfit = fees.times(rep).div(stake.plus(rep));
        var totalProfit = totalFeeProfit.minus(gasCost);
        var profitPerRep = totalProfit.div(rep);
        var profitPercent = totalProfit.div(gasCost.plus(rep.multipliedBy(repEthPrice)));
        var profitPercentPA = new BigNumber(Math.pow(profitPercent.toNumber() + 1, 365 / 7) - 1);
        var gasPriceBreakEven = totalFeeProfit.div(gasUsed);
        var divisor = fees.minus(gasCost);
        var numRepBreakEven = new BigNumber("+Infinity");
        var numRepMaxProfitPerRep = new BigNumber(0);
        if (divisor.gt(0)) {
            numRepBreakEven = gasCost.times(stake).dividedBy(divisor);
            numRepMaxProfitPerRep = numRepBreakEven.plus(numRepBreakEven.times(numRepBreakEven.plus(stake)).sqrt());
        }
        return {
            gasCost: gasCost,
            totalFeeProfit: totalFeeProfit,
            totalProfit: totalProfit,
            profitPerRep: profitPerRep,
            profitPercent: profitPercent,
            profitPercentPA: profitPercentPA,
            numRepBreakEven: numRepBreakEven,
            gasPriceBreakEven: gasPriceBreakEven,
            numRepMaxProfitPerRep: numRepMaxProfitPerRep,
        };
    };
    /**
     * Caution: If the fee window is over this method needs a lot of requests and therefore may be slow.
     * @param {string} address The address of the fee window to get
     * @param {boolean} isOver True, iff the fee window is over
     * @returns {Promise<FeeWindow>}
     */
    AugurFeeWindow.prototype.getFeeWindow = function (address, isOver) {
        if (isOver === void 0) { isOver = true; }
        return __awaiter(this, void 0, void 0, function () {
            var _a, _b, feeWindowContract, _c, strBalance, strTotalFeeStake, strEndTime, intEndTime, span, currentBlockNumber, numBlocks, blockNumber, balanceOfMethod, getTotalFeeStakeMethod, balance, totalFeeStake, endTime, err_6;
            return __generator(this, function (_d) {
                switch (_d.label) {
                    case 0:
                        _d.trys.push([0, 8, , 9]);
                        feeWindowContract = new this.web3.eth.Contract(feeWindowABI, address);
                        _c = ["0", "0", "0"], strBalance = _c[0], strTotalFeeStake = _c[1], strEndTime = _c[2];
                        if (!isOver) return [3 /*break*/, 5];
                        return [4 /*yield*/, feeWindowContract.methods.getEndTime().call()];
                    case 1:
                        //get historic view of the fee window
                        strEndTime = _d.sent();
                        intEndTime = parseInt(strEndTime);
                        span = (new Date()).valueOf() - intEndTime * 1000;
                        if (span <= 0) {
                            throw new Error("The fee window is not over yet!");
                        }
                        return [4 /*yield*/, this.web3.eth.getBlockNumber()];
                    case 2:
                        currentBlockNumber = _d.sent();
                        numBlocks = Math.round(span / 1000 / 15);
                        if (numBlocks < 10) {
                            numBlocks = 10; //get at least 10 blocks
                        }
                        return [4 /*yield*/, this.binarySearch(intEndTime, 0, currentBlockNumber, numBlocks)];
                    case 3:
                        blockNumber = _d.sent();
                        balanceOfMethod = this.cashContract().methods.balanceOf(address);
                        getTotalFeeStakeMethod = feeWindowContract.methods.getTotalFeeStake();
                        return [4 /*yield*/, Promise.all([
                                balanceOfMethod.call(undefined, blockNumber),
                                getTotalFeeStakeMethod.call(undefined, blockNumber)
                            ])];
                    case 4:
                        _a = _d.sent(), strBalance = _a[0], strTotalFeeStake = _a[1];
                        return [3 /*break*/, 7];
                    case 5: return [4 /*yield*/, Promise.all([
                            this.cashContract().methods.balanceOf(address).call(),
                            feeWindowContract.methods.getTotalFeeStake().call(),
                            feeWindowContract.methods.getEndTime().call()
                        ])];
                    case 6:
                        _b = _d.sent(), strBalance = _b[0], strTotalFeeStake = _b[1], strEndTime = _b[2];
                        _d.label = 7;
                    case 7:
                        balance = new BigNumber(strBalance).shiftedBy(-18);
                        totalFeeStake = new BigNumber(strTotalFeeStake).shiftedBy(-18);
                        endTime = new Date(parseInt(strEndTime) * 1000);
                        return [2 /*return*/, {
                                address: address.toLowerCase(),
                                balance: balance,
                                totalFeeStake: totalFeeStake,
                                endTime: endTime
                            }];
                    case 8:
                        err_6 = _d.sent();
                        throw new Error("getFeeWindow: " + err_6);
                    case 9: return [2 /*return*/];
                }
            });
        });
    };
    AugurFeeWindow.prototype.cashContract = function () {
        return new this.web3.eth.Contract(cashABI, DEFAULT_CASH_CONTRACT_ADDRESS);
    };
    AugurFeeWindow.prototype.universeContract = function () {
        return new this.web3.eth.Contract(universeABI, DEFAULT_UNIVERSE_CONTRACT_ADDRESS);
    };
    /**
     * Binary searching a block number
     * @param {number} target timestamp
     * @param {number} lowerBound timestamp
     * @param {number} upperBound timestamp
     * @param {number} numBlocks the number of blocks to step back if the lower bound is still to high
     * @returns {Promise<number>} The last block which was before or exactly at the time given by target
     */
    AugurFeeWindow.prototype.binarySearch = function (target, lowerBound, upperBound, numBlocks) {
        return __awaiter(this, void 0, void 0, function () {
            var nextTest, block, time, lBound, uBound;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (upperBound < lowerBound) {
                            return [2 /*return*/, upperBound];
                        }
                        nextTest = 0;
                        if (lowerBound === 0) {
                            nextTest = upperBound - numBlocks;
                        }
                        else {
                            nextTest = Math.floor((upperBound + lowerBound) / 2);
                        }
                        return [4 /*yield*/, this.web3.eth.getBlock(nextTest, false)];
                    case 1:
                        block = _a.sent();
                        time = block.timestamp;
                        lBound = lowerBound;
                        uBound = upperBound;
                        if (time > target) {
                            uBound = nextTest - 1;
                        }
                        else {
                            lBound = nextTest + 1;
                        }
                        return [2 /*return*/, this.binarySearch(target, lBound, uBound, numBlocks)];
                }
            });
        });
    };
    return AugurFeeWindow;
}());
export default AugurFeeWindow;
